# B-211_tui.py

from plugs_manage import *
import sys
import string
import cl_b211
import getopt
import convkeyb

#-----------------------------------------------------------
def usage():
    print "usage:   B-211_tui [option...] < message"
    print "  -i keyInt  The Internal key (default: an empty key!!!)"
    print "  -k keyExt  The External key (default: 'AAAAAAAAAA')"
    print "  -m mode    The mode: C|D (Cipher[default] or Decipher)"
    print "  -M model   The Model (default: B211)"
    print "  -r         Raw mode (only in deciphering mode)"
    print "  -d         The Debug mode (default: no Debug)"
    print "  -h         Help"
#-----------------------------------------------------------
#-----------------------------------------------------------
def restore(nomFichier):
    try:
        chemin = "KEYS/" + nomFichier + ".key"
        #print "chemin: ", chemin
        f = open( chemin, "r" )
    except:
        if nomFichier == "conf_b21" :
            return
        sys.stderr.write("Error: Impossible to open file\n")
        exit(1)
    try:
        c.zero()
        
        for i in range(8):
            ch = f.readline()
            for j in range(5):
                matrice_plugs[i][j] = ch[j]
        [ compatible, flag ] = valide_plugs( c, matrice_plugs )
        #print "c,f: ", compatible, flag
        if flag < 0: raise Exception('Incorrect format')
    
        for i in range(4):
            ch = f.readline().strip()
            lg = len(ch)
            for j in range(lg):
                if ch[j] != '_':
                    c.w[i].setPinsON( ch[j] )

    except:
        sys.stderr.write("Error: Impossible to read the file\n")
        exit(2)
    finally:
        f.close()

#-----------------------------------------------------------
#-----------------------------------------------------------
#========== Debut Programme ==================================
try:
  opts, args = getopt.getopt(sys.argv[1:], 
    "i:k:m:M:rdh", ["internal_key=", "external_key=","mode=",
    "model=", "raw", "debug", "help"])
except getopt.GetoptError as err: 
  # print help information and exit:
  print sys.argv[0],": ", str(err) # option -a not recognized"
  usage() 
  sys.exit(2)

DEBUG = 0
MODE_CIPHER = "C"
KEY_MESG  = "AAAAAAAAAA"
INTERNAL_KEY = ""
MODELE = "B211"
RAW_MODE = 0

for o, a in opts:
  if o in ("-i", "--internal_key"):
    INTERNAL_KEY = a
  elif o in ("-k", "--external_key"):
    KEY_MESG = a
  elif o in ("-m", "--mode"):
    MODE_CIPHER = string.upper( a[0:1] )
  elif o in ("-M", "--model"):
    MODELE = a
  elif o in ("-r", "--raw"):
    RAW_MODE = 1
  elif o in ("-d", "--debug"):
    DEBUG = 1
  elif o in ("-h", "--help"):
    usage()
    sys.exit()
  else:
    assert False, "unhandled option"

#------------------------------------------------
matrice_plugs = []
for i in range(8): matrice_plugs.append([' ']*5)

cryptogramme = ""
for ligne in sys.stdin:
    ligne = string.upper(ligne)
    cryptogramme = cryptogramme + ligne
#------------------------------------------------
f = open("rotors/" + MODELE + ".modele")
cle_rotv = f.readline().strip()
cle_rotc = f.readline().strip()
sur_s1   = f.readline().strip()
sur_s2   = f.readline().strip()
sur_s3   = f.readline().strip()
sur_s4   = f.readline().strip()
f.close()

c = cl_b211.B_211( cle_rotv, cle_rotc, sur_s1, sur_s2, sur_s3, sur_s4, DEBUG )
if INTERNAL_KEY != "":
    restore( INTERNAL_KEY )
c.setKey( KEY_MESG )  
if ( DEBUG ): c.info()

ch = ""
cB211 = convkeyb.CharB211()
for i in range(len(cryptogramme)):
    try:
        if ( MODE_CIPHER == "C" ):
            car = cB211.conv(  cryptogramme[i] )
            for un_car in car:
                ch += c.cipher( un_car )
        elif(MODE_CIPHER == "D" ):
            if cryptogramme[i] in "ABCDEFGHIJKLMNOPQRSTUVWXYZ":
                car = c.decipher( cryptogramme[i] )
                if RAW_MODE:
                    ch += car
                else:
                    ch += cB211.unconv( car )
    except:
        continue
print ch

