# B-21.py
# youpi: ca marche !!!!  (v1.0) JF BOUCHAUDY jfbouch@wanadoo.fr

import sys
import string
from cl_wheel import * 
from cl_fract import * 
from cl_halfrotor import *
from cl_plug  import *
from cl_surrotor import *

#========== Class B_211
class B_211:
    def __init__(self, rot_vow,rot_con,s1,s2,s3,s4,debug):
        self.w = []
        self.w.append( Wheel("ABCDEFGHIKLMNOPQRSTUVXY",6  ) )
        self.w.append( Wheel("ABCDEFGHIKLMNOPQRSTUV",5  ) )
        self.w.append( Wheel("ABCDEFGHIKLMNOPQRST",7  ) )
        self.w.append( Wheel("ABCDEFGHIKLMNOPQR",6  ) )    
        #f = open( "rotors/" + key_base + ".key", "r" )
        self.keyboard = Fraction("OPJCNHYBKLQVXDMUZFGRIASTE")
        self.touches = "OPJCNHYBKLQVXDMUZFGRIASTE"
        self.letters = "OPJCNHYB LQVXDMU<FGRIASTE"
        self.ciphers = "->0/,93.K! ?W6\"4Z7815+=2%"
        self.lights_and_keys = "OPJCNHYBKLQCXDMUZFGRIASTE"
        self.mode_lt = "LETTERS"
        self.mode_compatible = False
        self.mode_crossed = False
        self.mode_crossed2 = False
        self.plug_con = Plug( "IORST" )
        self.plug_con.setAllPlugs( "01234" )
        self.plug_con2= Plug( "PWXYZ" )
        self.plug_con2.setAllPlugs("01234" )
        self.plug_vow = Plug( "ADEGL" )
        self.plug_vow.setAllPlugs( "01234" )
        self.plug_vow2= Plug( "BCHKM" )
        self.plug_vow2.setAllPlugs("01234" )  
        
        self.nw = 4
        #for i in range( self.nw ):
        #    ch = f.readline()
        #    ch = ch.rstrip()
        #    lg = len(ch)
        #    for j in range(lg):
        #        if ch[j] != '.':
        #            self.w[i].setPinsON( ch[j] )
        self.rot_vow = HalfRotor(rot_vow)
        self.rot_con = HalfRotor(rot_con)
        self.surchi =  []
        self.surchi.append( SurRotor(s1))
        self.surchi.append( SurRotor(s2))
        self.surchi.append( SurRotor(s3))
        self.surchi.append( SurRotor(s4))        
        if ( debug ): self.DEBUG = 1 
        else: self.DEBUG = 0
        self.debug_info = ""

    def advance(self):
        global theWheels
        theWheels = " : "
        # 1 - Advance Wheels 
        for i in range( self.nw ):
            self.w[i].turnClockwise()
            if ( self.DEBUG ):
                #print self.w[i].getExternalKey(),
                theWheels += str( self.w[i].isActive() ) + " "
                #print self.w[i].isActive(),
                #print self.w[i].getExternalShiftedKey(),

        # 2 - Advance Half-Rotors and Surencipherment Rotors
        if ( self.w[0].isActive() or self.w[1].isActive() ):
            self.rot_vow.advance()
            self.surchi[1].advance()
            if ( self.surchi[1].getKey() == "I" ):
                self.surchi[0].advance()
        if ( self.w[2].isActive() or self.w[3].isActive() ):
            self.rot_con.advance()  
            self.surchi[3].advance()  
            if ( self.surchi[3].getKey() == "I" ):
                self.surchi[2].advance()

        if ( self.DEBUG ):
            theWheels += " : "
            theWheels +=  self.rot_vow.getKey() + " "
            theWheels +=  self.rot_con.getKey()
            theWheels += " : "
            if not self.mode_compatible:
                for i in range(4):
                   theWheels +=  self.surchi[i].getKey() 
                theWheels += " ! "

    def goBack(self):
        # 2 - go Back Half-Rotors and suencipherment Rotors
        if ( self.w[0].isActive() or self.w[1].isActive() ):
            self.rot_vow.goBack()
            self.surchi[1].goBack()
        if ( self.w[2].isActive() or self.w[3].isActive() ):
            self.rot_con.goBack()  
            self.surchi[3].goBack()  

        # 1 - go Back Wheels 
        for i in range( self.nw ):
            self.w[i].turnCounterClockwise()
            if ( self.DEBUG ):
                pass
                #print self.w[i].getExternalKey(),
                #print self.w[i].isActive(),
                #print self.w[i].getExternalShiftedKey(),

        if ( self.DEBUG ):
            pass
            #print self.rot_vow.getKey(),
            #print self.rot_con.getKey(),

    def cipher(self, letter ):
        global theWheels
        if ( self.DEBUG):
            dbgln = letter + " "

        # 1 - Advance wheel, half-rotors and surencipherment rotors
        self.advance()
                
        # 2 - Keyboard ( plain letter -> biliterals )
        [ v, c ] = self.keyboard.letter2bili( letter )
        if ( self.DEBUG ):    
            dbgln += theWheels 
            dbgln +=  "K>%d:%d-" % (v,c)
        
        # 3 - Cipher v and c
        v = self.rot_vow.cipher( v )
        c = self.rot_con.cipher( c )
        if ( self.DEBUG ):    
            dbgln +=  "R>%d:%d-" % (v,c)

        # 4 - Plugboard (first)
        v = self.plug_vow.cipher( v )
        c = self.plug_con.cipher( c )
        if self.mode_crossed:
            v, c = c, v
        if ( self.DEBUG ):    
            dbgln +=  "P>%d:%d-" % (v,c)

        #=====Compatible Mode: the Surencipherment and second Plug are skiped
        if not self.mode_compatible:

            # 5 - Surencipherment rotors
            v = self.surchi[1].cipher ( self.surchi[0].cipher(v) )
            c = self.surchi[2].cipher ( self.surchi[3].cipher(c) )
            if ( self.DEBUG ):
                dbgln +=  "S>%d:%d-" % (v,c) 

            # 6 - Plugboard (second)
            v = self.plug_vow2.cipher( v )
            c = self.plug_con2.cipher( c )
            if self.mode_crossed2:
                v, c = c, v
            if ( self.DEBUG ):    
                dbgln +=  "P>%d:%d-" % (v,c)

        # 7 - Lampboard ( biliterals -> cipher letter)
        new_letter = self.keyboard.bili2letter( v, c )
        if ( self.DEBUG ):
            dbgln += new_letter
            self.debug_info += dbgln + "\n"
            print dbgln 

        return new_letter

    def decipher(self, letter ):
        global theWheels
        if ( self.DEBUG):
            dbgln =  letter + " "

        # 1 - Advance wheels and half-rotors
        self.advance()

        # 2 - Keyboard ( plain letter -> biliterals )
        [ v, c ] = self.keyboard.letter2bili( letter )
        if ( self.DEBUG ):    
            dbgln += theWheels
            dbgln +=  "K>%d:%d-" % (v,c)

        #=====Compatible Mode: the Surencipherment and second Plug are skiped
        if not self.mode_compatible:

            # 3 - Plugboard (second)
            if self.mode_crossed2:
                v, c = c, v
            v = self.plug_vow2.decipher( v )
            c = self.plug_con2.decipher( c )
            if ( self.DEBUG ):    
                dbgln +=  "P>%d:%d-" % (v,c)

            # 5 - Surencipherment rotors
            v = self.surchi[0].decipher ( self.surchi[1].decipher(v) )
            c = self.surchi[3].decipher ( self.surchi[2].decipher(c) )
            if ( self.DEBUG ):
                dbgln +=  "S>%d:%d-" % (v,c) 

        # 6 - Plugboard (first)
        if self.mode_crossed:
            v, c = c, v
        v = self.plug_vow.decipher( v )
        c = self.plug_con.decipher( c )
        if ( self.DEBUG ):    
            dbgln +=  "P>%d:%d-" % (v,c)

        # 4 - UnCipher v and c
        v = self.rot_vow.decipher( v )
        c = self.rot_con.decipher( c )
        if ( self.DEBUG ):    
            dbgln +=  "R>%d:%d-" % (v,c)

        # 5 - Lampboard ( biliterals -> cipher letter)
        new_letter = self.keyboard.bili2letter( v, c )
        if ( self.DEBUG ):
            dbgln += new_letter
            self.debug_info += dbgln + "\n"
            print dbgln
        return new_letter

    def getMode_lt(self):
        return self.mode_lt

    def setMode_lt(self, newmode):
        self.mode_lt = newmode

    def printl(self, letter):
        indx = self.touches.find(letter)
        mode = self.mode_lt 
        if mode == "LETTERS":
            new_letter = self.letters[ indx ]   
            if new_letter == "<" :
                mode = "DIGITS"
                new_letter = ""
        else:
            new_letter = self.ciphers[ indx ]
            if new_letter == ">" :
                mode = "LETTERS"
                new_letter = ""
        return [new_letter,mode]

    def setKey(self, key ):
        for i in range(4):
            self.surchi[i].setKey( key[i] )
        self.rot_vow.setKey( key[4] )
        self.rot_con.setKey( key[5] )
        for i in range( self.nw ):
            self.w[i].setKey( key[ i + 6 ] )

    def setCompatibleMode(self, trueOrFalse ):
        self.mode_compatible = trueOrFalse 
        if self.DEBUG:
            print "compatible:", self.getCompatibleMode()

    def getCompatibleMode(self):
        return self.mode_compatible

    def setCrossedMode(self, trueOrFalse ):
        self.mode_crossed = trueOrFalse 
        if self.DEBUG:
            print "crossed:", self.getCrossedMode()

    def getCrossedMode(self):
        return self.mode_crossed

    def setCrossed2Mode(self, trueOrFalse ):
        self.mode_crossed2 = trueOrFalse 
        if self.DEBUG:
            print "crossed2:", self.getCrossed2Mode()

    def getCrossed2Mode(self):
        return self.mode_crossed2

    def info(self):
        print "Compatible: ", self.mode_compatible
        print "Crossed: ", self.mode_crossed
        print "Crossed2: ", self.mode_crossed2
        self.keyboard.info()
        for i in range( self.nw ):    
            self.w[i].info()
        self.rot_vow.info()
        self.rot_con.info()
        self.plug_vow.info()
        self.plug_con.info()
        if not self.mode_compatible:
            self.plug_vow2.info()
            self.plug_con2.info()
            for i in range( 4 ):    
                self.surchi[i].info()
        print self.getMsgKey()

    def getMsgKey(self):
        ch = ""
        if not self.mode_compatible:
            for i in range(4):
                ch += self.surchi[i].getKey()
        ch = ch + self.rot_vow.getKey()
        ch = ch + self.rot_con.getKey()
        for i in range( self.nw ):
            ch = ch + self.w[i].getExternalKey()
        return ch

    def zero(self):
        self.rot_vow.setKey("A")
        self.rot_con.setKey("A")
        for i in range( self.nw ):
            self.w[i].zero()
        for i in range(4):
            self.surchi[i].setKey("A")
        self.plug_con.zero()
        self.plug_vow.zero()
        self.plug_con2.zero()
        self.plug_vow2.zero()
        self.resetHistory()

    def getHistory(self):
        return self.debug_info

    def toggleDebug(self):
        if self.DEBUG : 
            self.DEBUG=0
            self.resetHistory()
        else: 
            self.DEBUG=1
        return self.DEBUG

    def resetHistory(self):
        self.debug_info = ""

#========== Debut Programme
if __name__ == "__main__":

    m = B_21("r1base","r1vowel","r1conso", 1)
    m.setKey("AARQML")  # internal Wheel Key = AAAA
    m.info()

    plain = "YOURBATTALIONWILLSUPPORTFOURTHREGIMENTATGREENVILLE"
    crypto = ""
    for letter in list(plain):
        crypto = crypto + m.cipher( letter )
    print crypto

    print "A try of deciphering"
    m.setKey("AARQML")  # internal Wheel Key = AAAA
    crypto= "NCYQHBWIUPESDAEHUDRLUMYFYPQUUXAWMBNRIQCTTJLIWOYLMB"
    plain = ""
    for letter in list(crypto):
        plain = plain + m.decipher( letter )
    print plain
    print
    m.setKey("AAAAAA")
    m.advance() ; print
    m.advance() ; print
    m.advance() ; print
    m.goBack()  ; print
    m.goBack()  ; print
    m.goBack()  ; print
