# cl_surrotor.py

import sys
import string

#========== Class SurRotor
class SurRotor:
    def __init__(self,nomDuRotor):
        f = open("rotors/"+nomDuRotor+".rot","r")
        self.alpha = (f.readline()).strip()
        self.nwires = len( self.alpha )
        self.decal = []
        self.decal_inv = []
        for k in range(15):
            PI = f.readline()
            #print PI
            self.decal.append( [0]*5 )
            self.decal_inv.append( [0]*5 )
            tampon = [0]*5
            for i in range(5):
                indice = int(PI[i])
                self.decal[k][i] = (indice - i + 5) % 5
            for i in range(5):
                tampon[ int( PI[i] ) ] = i
            for i in range(5):
                self.decal_inv[k][i] = ( tampon[i] - i + 5 ) %5
        self.index = 0
        
    def getKey(self):
        return self.alpha[ self.index ]

    def setKey(self,key):
        self.index = string.find( self.alpha, key )

    def getPosition(self):
        return self.index

    def advance(self):
        self.index = (self.index + 1) % self.nwires

    def goBack(self):
        self.index = (self.index - 1 + self.nwires) % self.nwires

    def cipher(self,x):
        nc = self.index % 3
        ni = self.index / 3
        return (x + self.decal[nc][ ( x + ni + 5 ) % 5]) % 5

    def decipher(self,x):
        nc = self.index % 3
        ni = self.index / 3
        return (x + self.decal_inv[nc][ ( x + ni + 5 ) % 5 ]) % 5

    def info(self):
        print "Alphabet: ",  self.alpha
        print "Length : ", self.nwires
        for i in range(len(self.decal)):
            print self.decal[i], self.decal_inv[i]

if __name__ == "__main__":
    r = SurRotor("s1")
    r.info()

    for i in range(20):
        print "%3d: " % i,
        for j in range(5):
            print r.cipher(j),
        print "====",
        for j in range(5):
            print r.decipher(j),
        print "####", r.getPosition()
        r.advance()
