# convkeyb.py

import sys
import string

#------------------------------------------------------------
def typeOfChar( lettre ):
    alpha_letters = "OPJCNHYBLQVXDMUFGRIASTE"
    alpha_ciphers = "-0/,93.K!?W6\"4Z7815+=2%"

    if   lettre in alpha_letters:
        return 1
    elif lettre in alpha_ciphers:
        return 2
    elif lettre == ' ':
        return 3
    else:
        return 0

#------------------------------------------------------------
dico = {     'O':'O','P':'P','J':'J','C':'C','N':'N',
             '-':'O',        '0':'J','/':'C',',':'N',
             'H':'H','Y':'Y','B':'B','K':'K','L':'L',
             '9':'H','3':'Y','.':'B',        '!':'L',
             'Q':'Q','V':'V','X':'X','D':'D','M':'M',
                     '?':'V','W':'X','6':'D','"':'M',
             'U':'U',        'F':'F','G':'G','R':'R',
             '4':'U','Z':'Z','7':'F','8':'G','1':'R',
             'I':'I','A':'A','S':'S','T':'T','E':'E',
             '5':'I','+':'A','=':'S','2':'T','%':'E',
}
dico_inv={   'O':'-','H':'9','U':'4','I':'5','L':'!',
             'J':'0','Y':'3','V':'?','A':'+','C':'/',
             'B':'.','X':'W','F':'7','S':'=','N':',',
             'K':'*','D':'6','G':'8','T':'2','M':'"',
             'R':'1','E':'%'
}
#------------------------------------------------------------
class CharB211:
    def __init__(self):
        self.MODE = 'LETTERS'

    def reset(self):
        self.MODE = 'LETTERS'
        
    def unconv( self, car ):
        lettre = car
        if self.MODE == 'LETTERS':
            if   lettre == 'K':
                sortie = ' '
            elif lettre == 'Z':
                self.MODE = 'CIPHERS'
                sortie = ''
            else:
                sortie = lettre
        elif self.MODE == 'CIPHERS':
            if   lettre == 'Q':
                sortie = ' '
            elif lettre == 'P':
                self.MODE = 'LETTERS'
                sortie = ''
            else:
                une_lettre = dico_inv[ lettre ]
                if une_lettre == '*':
                    sortie = 'K'
                else:
                    sortie = une_lettre
        else:
            sortie = ''
        return sortie

    def conv( self, car ):
        lettre = string.upper( car )
        t = typeOfChar( lettre )
        if t == 4: 
            sortie = ''
        if t == 3 and self.MODE == 'LETTERS':
            sortie = "K"
        if t == 3 and self.MODE == 'CIPHERS':
            sortie = "Q"
        if t == 2 and self.MODE == 'CIPHERS':
            sortie = dico[ lettre ]
        if t == 1 and self.MODE == 'LETTERS':
            sortie = lettre
        if t == 1 and self.MODE == 'CIPHERS':
            self.MODE = 'LETTERS'
            sortie = "P" + lettre
        if t == 2 and self.MODE == 'LETTERS':
            self.MODE = 'CIPHERS'
            sortie = "Z" + dico[ lettre ]
        return sortie

    def convall( self, ch ):
        ch_out = ""
        for car in ch:
            ch_out += self.conv( car )
        return ch_out

    def getMode( self  ):
        return self.MODE
    
#------------------------------------------------------------
if __name__ == "__main__":
    tbLet = []
    c = CharB211()

    print ">>>> conversion plain (red and black signs) to letters"
    tbPlain = ["il fait","prix = 375,44 euros","2 + 2 = quatre",\
               "A!B", "NARVIK EST"]
    for ch in tbPlain:
        ch_out = ""
        for car in ch:
            ch_out += c.conv( car )
        print ch, "\n", ch_out, "\n"
        tbLet.append( ch_out )
    print ">>>> global conversion: ",
    print c.convall( tbPlain[1] ) 
    
    c.reset()
    print ">>>> conversion letters to plain"
    for ch in tbLet:
        ch_out = ""
        for car in ch:
            ch_out += c.unconv( car )
        print ch, "\n", ch_out ,"\n"
        
